searchNodes=[{"ref":"EctoPostgresEnum.html","title":"EctoPostgresEnum","type":"module","doc":"Helper module to define enum for ecto and PostgreSQL with support for dynamic values. Usage defmodule MyEnum do values = [:my, :enum] use EctoPostgresEnum, schema: :my_schema, type: :my_type, values: values end Options schema - Allows to change PostgreSQL Schema for specified enum. type - Allows to change type identifier. It&#39;s useful for migrations and required by Ecto.Type.type/0 callback. NameTypeRequiredDefault schemaatomfalsenil (fallbacks to PostgreSQL default: &quot;public&quot;) typeatomfalseatom (underscored last module part) valueslist(atom)trueN/A Debug This library automatically generates few useful functions to work with allowed values. Example usage: defmodule MyEnum do values = [:my, :enum] use EctoPostgresEnum, schema: :my_schema, type: :my_type, values: values end defmodule MyApp do require MyEnum def handle_user_input(input) when MyEnum.valid_string?(input) do IO.puts &quot;Alright, \#{input} is allowed value!&quot; end def handle_user_input(input) do IO.puts &quot;Ooops, \#{input} is not allowed value! Please try again …&quot; end end MyApp.handle_user_input(&quot;my&quot;) {:ok, &quot;my&quot;} MyApp.handle_user_input(&quot;something&quot;) {:error. &quot;Wrong enum value!&quot;}"},{"ref":"ecto_postgres_enum.html","title":"EctoPostgresEnum","type":"extras","doc":"EctoPostgresEnum Library which simplifies using PostgreSQL enums"},{"ref":"ecto_postgres_enum.html#installation","title":"EctoPostgresEnum - Installation","type":"extras","doc":"The package can be installed by adding ecto_postgres_enum to your list of dependencies in mix.exs: def deps do [ {:ecto_postgres_enum, &quot;~&gt; 1.0&quot;} ] end"},{"ref":"ecto_postgres_enum.html#usage","title":"EctoPostgresEnum - Usage","type":"extras","doc":"To define enum simply use EctoPostgresEnum module like: defmodule MyEnum do values = [:my, :enum] use EctoPostgresEnum, values: values end # automatically generated type MyEnum.type() == :my_enum You can optionally define schema and type: defmodule MyEnum do values = [:my, :enum] use EctoPostgresEnum, schema: :my_schema, type: :my_type, values: values end For more informations please take a look at EctoPostgresEnum module. After it add such enum to your schema like: defmodule MySchema do use Ecto.Schema alias Ecto.Changeset schema &quot;my_table&quot; do field :my_field, MyEnum # add this end def changeset(my_element, my_params) do Changeset.cast(my_element, my_params, [:my_field]) # cast as any other field end end Finally you will also need to create migration like: defmodule Example.Repo.Migrations.MyEnum do use Ecto.Migration def up do MyEnum.create_db_enum() alter table(:my_table) do add :my_field, :my_enum # when automatically generated # or add :my_field, :my_type # when manually set end end def down do # Remember to remove all fields which are using your enum. # Otherwise migration would fail! alter table(:my_table) do remove :my_field end MyEnum.drop_db_enum() end end"}]